<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Create ServiceType
 * @subpackage Services
 */
class Create extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named CreateAgent
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\CreateAgent $parameters
     * @return \StructType\CreateAgentResponse|bool
     */
    public function CreateAgent(\StructType\CreateAgent $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->CreateAgent($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named CreateReferral
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\CreateReferral $parameters
     * @return \StructType\CreateReferralResponse|bool
     */
    public function CreateReferral(\StructType\CreateReferral $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->CreateReferral($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named CreateApplicationTaken
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\CreateApplicationTaken $parameters
     * @return \StructType\CreateApplicationTakenResponse|bool
     */
    public function CreateApplicationTaken(\StructType\CreateApplicationTaken $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->CreateApplicationTaken($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\CreateAgentResponse|\StructType\CreateApplicationTakenResponse|\StructType\CreateReferralResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
